<template>
  <div id="ListComponent">
    <hr />
    <br />
    <h1>{{ msg }}</h1>
    <br />
    <hr />
    <br /><button
      v-bind:title="msg_btn"
      v-on:click="incrementMe(), doubleClickReset($event)"
      class="btn"
      v-bind:class="{ 'btn-success': greenColor, 'btn-danger': redColor }"
    >
      My Count: {{ count }}
    </button>

    <div class="mt-2">
      <div v-if="greenColor">
        <h4> {{ firstToUpper() | capitalize }}</h4>
      </div>
      <div v-else-if="redColor">
        <h4>WoW, you already clicked {{ count }} times.</h4>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
export default {
  name: "ListComponent",
  data() {
    return {
      msg: "Welcome to Your Vue.js App",
      msg_btn: "Click to add, Doubleclick to reset !",
      count: 0,
      maxTimeDoubleClick: 150,
      lastClick: 0,
      greenColor: true,
      redColor: false,
    };
  },
  watch: {
    count: {
      handler: (newValue: number, oldValue: number) => {
        if (newValue === 0) {
          console.log("Number Reset");
        }
      },
      deep: true,
    },
  },
  methods: {
    /**
     * Increment the value of the property count
     */
    incrementMe(): void {
      this.count++;
      this.$emit("count", this.count);
      this.changeColor();
    },
    /**
     * If double clicked, the property count will be resetted
     */
    doubleClickReset(e: any): void {
      const timeBetweenClicks = e.timeStamp - this.lastClick;

      if (timeBetweenClicks > this.maxTimeDoubleClick) {
        this.lastClick = e.timeStamp;
        return;
      }

      this.count = 0;
      this.$emit("count", this.count);
      this.changeColor();
    },
    /**
     * Change the color of the button depending on the number of the count
     */
    changeColor(): void {
      if (this.count >= 10) {
        this.greenColor = false;
        this.redColor = true;
        return;
      }

      this.greenColor = true;
      this.redColor = false;
    },
    firstToUpper(): any {
      return "woW, you only clicked " + this.count + " times.";
    }
  },
};
</script>
